#ifndef __CIDR_H__
#define __CIDR_H__

#include "ircd_includes.h"

#define cidr_last_addr(__x, __y)	(~(__y) | (__x))

/* ALL CIDR FUNCTIONS RETURN INFO IN _HOST BYTE_ ORDER */

int cidr_valid(char *ip);
int cidr_ip2netmask(char *ip, ircd_uint32_t *net, ircd_uint32_t *mask);
ircd_uint32_t cidr_string2ip(char *ipstr);
int cidr_match(ircd_uint32_t net, ircd_uint32_t mask, ircd_uint32_t ip);
int cidr_netmask_to_plength(ircd_uint32_t netmask);

#endif
