#ifndef __DEFINES_H__
#define __DEFINES_H__

#define CRYPT_OPER_PASSWORD

#define CHANNELLEN	200
#define MAXMODEPARAMS		4

/* CANT CHANGE THESE WITHOUT NEEDING TO CONVERT */
#define NICKLEN		9
#define USERLEN		10
#define HOSTLEN		64
#define REALLEN		50
#define PASSWDLEN	40

#define CLIENTNAMESIZE	(HOSTLEN*2 + 30 + 5)

#define	HUNTED_ISME			1
#define HUNTED_PASS			2
#define HUNTED_NOSUCH		3

typedef char				ircd_int8_t;
typedef unsigned char		ircd_uint8_t;
typedef short				ircd_int16_t;
typedef unsigned short		ircd_uint16_t;
typedef int					ircd_int32_t;
typedef unsigned int		ircd_uint32_t;

#include "config.h"
#include "setup.h"
#include "structs.h"
#include "fdlist.h"
#include "structs.h"
#include "conf.h"

#ifdef DEBUG
#undef DEBUG
#define DEBUG(_y, _x) printf _x,fflush(stdout)
#define DEBUG_ALL	10
#else
#define DEBUG(_y, _x)
#endif

#if (__GNUC__ < 2) || (__GNUC__ == 2 && __GNUC_MINOR__ < 7)
#define RCSID(id) \
    static char rcsid[] = id
#else
#define RCSID(id) \
    static char rcsid[] __attribute__ ((unused)) = id
#endif

#define ISWHITE(__x)     (((__x) == ' ') || ((__x) == '\t'))
#define IsChannel(__x)	((*(__x) == '#') || (*(__x) == '&'))
#define isvalid(c) (((c) >= 'A' && (c) <= '~') || isdigit(c) || (c) == '-')
#define IsMe(__x)			((__x) == meptr)
#define IsMember			_channel_ismember

extern char				*Conffile;
extern FDLIST			*Fdlist_main;
extern IRCD_CONN		**Fds;
extern int				Fds_size;
extern IRCDRES_REQLIST	*Reqlist;
extern IRCD_CLIENT		*Locals;
extern IRCD_AUTH		*Auths;
extern IRCD_CLIENT		**Opers;
extern IRCD_CLIENT		**Clients;
extern IRCD_CLIENT		**Servers;
extern IRCD_CLIENT		**Flooders;
extern IRCD_CHANNEL		*Channels;
extern int				ircd_pagesize;
extern GLOBALSTATS		*Globalinfo;
extern IRCD_MOTD		*Motd;
extern IRCD_REJECTHOLD	*Rejectholds;
extern int				Sendbuffersize;
extern int				Recvbuffersize;
extern unsigned int		*Sentalong;
extern unsigned int		Sentalong_marker;
extern unsigned int		*Sentalong_end;
extern int				Sentalong_size;
extern IRCD_CLIENT		*meptr;
extern IRCD_CONN		*Ircd_resconn;

extern int				Now;
extern int				DoRehash;
extern char				*RehashWho;
extern int				Rehashed;
extern int				Autoconncheck;
extern int				Flooders_did_delete;
extern int				Auths_did_delete;

extern IRCD_USERFLAG	_user_flags[];

#ifndef MAP_ANON
extern int Ircd_zero_fd;
#endif
#define REMOVE_CLIENTS_IMMEDIATELY

#endif
