#ifndef __IPHASH_H__
#define __IPHASH_H__

#include "structs.h"


int iphash_init(void);
IRCD_IPENTRY *ipentry_find(IRCD_NETHASH *nhptr, ircd_uint32_t ipaddr);
int iphash_handle_accept(ircd_uint32_t ipaddr);
int iphash_handle_client(IRCD_CLIENT *pptr);
int iphash_handle_exit(IRCD_CLIENT *pptr);
int iphash_cleanup(void);
int iphash_command(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *args);
int iphash_count_memory(int *num_nethash, int *num_ips, int *size_nethash);
int iphash_init_reload(void ***nethash, int nethash_size, void *clones, void *throttles);
int iphash_deinit_reload(void ****nethash, int *nethash_size, void **clones, void **throttles);

#endif
