#ifndef __WHOWAS_H__
#define __WHOWAS_H__

#include "structs.h"
#include "hash.h"

void whowas_add_history(IRCD_CLIENT *cptr, int online);
void whowas_off_history(IRCD_CLIENT *cptr);
IRCD_CLIENT *whowas_get_history(char *nick, int timelimit);
void whowas_count_memory(int *wwu, unsigned int *wwum, unsigned int *whowas_array_size);
int whowas_init(void);
int whowas_command(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args);
int whowas_init_reload(void *whowasarr, int whowas_size, void **whowashash, int whowas_hash_size, int whowas_next);
int whowas_deinit_reload(void **whowasarr, int *whowas_size, void ***whowashash, int *whowas_hash_size, int *whowas_next);

#endif
