#ifndef __LOGS_H__
#define __LOGS_H__

#include <sys/types.h>
#include "fileio.h"

typedef struct _log aLog;

struct _log
{
	char		*filename;
	u_long		last_attempt;
	aFileBuf	*fb;
};

int log_samename(aLog *log, char *filename);
aLog *log_open(char *filename);
void log_close(aLog *log);
void log_flush(aLog *log);
int log_printf(aLog *log, char *format, ...);
int log_write(aLog *log, char *buffer, int size);

#endif
