#ifndef __MYSOCKET_H__
#define __MYSOCKET_H__

#include "defines.h"

#define MYSOCKET_FLAGS_REUSEADDR	0x001
#define MYSOCKET_FLAGS_KEEPALIVE	0x002
#define MYSOCKET_FLAGS_NONBLOCKING	0x004

int mysocket_set_nonblocking(int fd);
int mysocket_listenport(ircd_uint32_t ipaddr, ircd_uint16_t port, int flags);
int mysocket_connectip(ircd_uint32_t ip, ircd_uint16_t port, ircd_uint32_t bindip, int flags);

#endif
