#ifndef __SEND_H__
#define __SEND_H__

#include "structs.h"

#define CHANNEL_SEND_SERVERS		0x001
#define CHANNEL_SEND_CLIENTS		0x002
#define CHANNEL_SEND_LOCALONLY		0x004

int send_to_client(IRCD_CLIENT *pptr, char *format, ...);
int send_prefix_to_client(IRCD_CLIENT *from, IRCD_CLIENT *to, char *format, ...);
int send_to_opers(char *format, ...);
int send_to_flag(int flag, IRCD_CLIENT *one, char *format, ...);
int send_wallops_to_flag(int flag, IRCD_CLIENT *one, IRCD_CLIENT *from, char *format, ...);
int send_to_servers(IRCD_CLIENT *one, char *format, ...);
int send_to_common_channels(IRCD_CLIENT *pptr, char *format, ...);
#if 0
int send_to_match_servs(IRCD_CHANNEL *chptr, IRCD_CLIENT *from, char *format, ...);
int send_to_channel_butserv(IRCD_CHANNEL *chptr, IRCD_CLIENT *from, char *format, ...);
#endif
int send_to_channel_butone(IRCD_CLIENT *one, int servstoo, IRCD_CHANNEL *chptr, IRCD_CLIENT *pptr, char *format, ...);
int send_to_channel_butone2(IRCD_CLIENT *one, int servstoo, IRCD_CHANNEL *chptr, char *prefix, char *format, ...);

#endif
