#include <stdio.h>
#include "cidr.h"

int main(int argc, char **argv)
{
	int	ret;
	ircd_uint32_t	net;
	ircd_uint32_t	mask;


	if (argc < 2)
	{
		fprintf(stderr, "Usage: cidrtest <ip>\n");
		exit(-1);
	}
	ret = cidr_ip2netmask(argv[1], &net, &mask);
	if (ret == 0)
	{
		printf("Invalid IP given\n");
		exit(0);
	}
	printf("%i %u %u\n", ret, (unsigned int)net, (unsigned int)mask);

	printf("%s\n", inet_ntoa(*((struct in_addr *)&net)));
	printf("%s\n", inet_ntoa(*((struct in_addr *)&mask)));

	exit(0);
}
